<?php

function get_content($keyword)
{
  GLOBAL $proxy_array, $browser_array;

  $set_proxy = 0;

  $url_array = array(
'https://www.bing.com/search?format=rss&count=50&q='.urlencode($keyword),
'http://www.ask.com/web?q='.urlencode($keyword),
'http://search.yahoo.com/search;_ylt=At4BiY60OAntDVulrn4jcUGbvZx4?n=100&p='.urlencode($keyword),
'https://nova.rambler.ru/search?sort=3&pagelen=50&adult=soft&lang=en&query='.urlencode($keyword),
'https://duckduckgo.com/html/?q='.urlencode($keyword),
'https://search.aol.com/aol/search?s_chn=prt_bon&s_it=comsearch&q='.urlencode($keyword),
'https://www.ecosia.org/search?q='.urlencode($keyword),
'https://lite.qwant.com/?t=all&q='.urlencode($keyword)
);

  if ($set_proxy==1)
  {
    if (!$proxy_array) $proxy_array=file("files/proxy.txt",FILE_IGNORE_NEW_LINES);

    $proxy = $proxy_array[mt_rand(0,count($proxy_array)-1)];
  }

  $count = count($url_array);

  $mh = curl_multi_init();
  for ($i=0; $i<$count; $i++)
  {
    $ch[$i] = curl_init();

    curl_setopt($ch[$i],CURLOPT_URL,$url_array[$i]);
    curl_setopt($ch[$i],CURLOPT_HEADER,false);
    curl_setopt($ch[$i],CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch[$i],CURLOPT_DNS_CACHE_TIMEOUT,600);
    curl_setopt($ch[$i],CURLOPT_TIMEOUT,10);
    curl_setopt($ch[$i],CURLOPT_CONNECTTIMEOUT,6);
    curl_setopt($ch[$i],CURLOPT_USERAGENT,'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.56 (KHTML, like Gecko) Chrome/56.0.1750.154 Safari/537.36');
    curl_setopt($ch[$i],CURLOPT_HTTPHEADER,array('Accept-Language: en'));
    curl_setopt($ch[$i],CURLOPT_SSL_VERIFYPEER,false); 
    curl_setopt($ch[$i],CURLOPT_SSL_VERIFYHOST,false); 
    curl_setopt($ch[$i],CURLOPT_ENCODING,'gzip');
    curl_setopt($ch[$i],CURLOPT_COOKIE,"SRCHHPGUSR=NRSLT=50");
    curl_setopt($ch[$i],CURLOPT_FTP_SSL,CURLFTPSSL_TRY);
    if ($set_proxy==1)
    {
      curl_setopt($ch[$i],CURLOPT_PROXY,$proxy);
      curl_setopt($ch[$i],CURLOPT_PROXYTYPE,CURLPROXY_SOCKS5);
    }

    curl_multi_add_handle($mh,$ch[$i]);
  }

  do { curl_multi_exec($mh,$running); } while ($running>0);

  unset($array);
  for ($i=0; $i<$count; $i++)
  {
    $content = curl_multi_getcontent($ch[$i]);
    if ($i==0) $array['bing']=get_bing($content);
    if ($i==1) $array['ask']=get_ask($content);
    if ($i==2) $array['yahoo']=get_yahoo($content);
    if ($i==3) $array['rambler']=get_rambler($content);
    if ($i==4) $array['duckduckgo']=get_duckduckgo($content);
    if ($i==5) $array['aol']=get_aol($content);
    if ($i==6) $array['ecosia']=get_ecosia($content);
    if ($i==7) $array['qwant']=get_qwant($content);

    curl_multi_remove_handle($mh,$ch[$i]);
  }

  curl_multi_close($mh);

  $array2 = array();
  foreach ($array as $key=>$value)
  {
    if (is_array($value)) $array2=array_merge($array2,$value);
  }

  $array2 = array_unique($array2);

  shuffle($array2);

  return ($array2);
}






function get_bing($content)
{
  unset($match);
  if (preg_match_all('!<description>(.*?)</description>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<title>(.*?)</title>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}



function get_ask($content)
{
  unset($match);
  if (preg_match_all('!<p class=\"PartialSearchResults-item-abstract\">(.*?)</p>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = html_entity_decode($value2,ENT_QUOTES,"utf-8");
      $value2 = trim(preg_replace('!<a.*?>.*?</a>!si','',$value2));
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<a class="PartialSearchResults-item-title-link result-link".*?>(.*?)</a>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = html_entity_decode($value2,ENT_QUOTES,"utf-8");
      $value2 = trim(preg_replace('!<a.*?>.*?</a>!si','',$value2));
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}



function get_yahoo($content)
{
  unset($match);
  if (preg_match_all('!<div class="compText aAbs" ><p class=".*?">(.*?)</p></div>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = preg_replace('!<span.*?>.*?</span>!si','',$value2);

      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<h3 class="title"><a.*?>(.*?)</a></h3>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = preg_replace('!<span.*?>.*?</span>!si','',$value2);

      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}



function get_rambler($content)
{
  unset($match);
  if (preg_match_all('!<p class="b-serp-item__snippet">(.*?)</p>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<h2 class="b-serp-item__header"><a.*?>(.*?)</a></h2>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}



function get_duckduckgo($content)
{
  unset($match);
  if (preg_match_all('!<a class="result__snippet" href=".*?">(.*?)</a>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<h2 class="result__title">.*?<a.*?>(.*?)</a>.*?</h2>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}


function get_aol($content)
{
  unset($match);
  if (preg_match_all('!<p property="f:desc">(.*?)</p>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<h3 class="hac">.*?<a.*?>(.*?)</a>.*?</h3>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}



function get_ecosia($content)
{
  unset($match);
  if (preg_match_all('!<p class="result-snippet">(.*?)</p>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<a class="result-title js-result-title".*?>(.*?)</a>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}



function get_qwant($content)
{
  unset($match);
  if (preg_match_all('!<div class="result">.*?<p>(.*?)</p>!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = $value2;
      }
    }
  }

  unset($match);
  if (preg_match_all('!<div class="result">.*?<span class="title">.*?<a.*?>(.*?)</a>.*?</span!si',$content,$match)>0)
  {
    unset($match[1][0]);
    foreach ($match[1] as $key2=>$value2)
    {
      $value2 = clean($value2);
      $value2 = strip_tags($value2);
      $value2 = toUpper($value2[0]).substr($value2,1);
      $value2 = preg_replace('! {2,}!',' ',$value2);
      $value2 = preg_replace("!^.*?\.(com|ru|su|org|php|htm|html) !si", " ", $value2);
      if (stristr($value2,'•')) continue;
      if (strlen($value2)>30 and (substr_count($value2,'«')==substr_count($value2,'»') and substr_count($value2,'(')==substr_count($value2,')') and substr_count($value2,'[')==substr_count($value2,']')))
      {
        $array[] = '<b>'.$value2.'</b>';
      }
    }
  }

  return($array);
}



if (!function_exists("toLower"))
{
function toLower($content)
{
  $content = strtr($content, "АБВГДЕЁЖЗИЙКЛМНОРПСТУФХЦЧШЩЪЬЫЭЮЯ","абвгдеёжзийклмнорпстуфхцчшщъьыэюя");
  return (strtolower($content));
}
}



if (!function_exists("toUpper"))
{
function toUpper($content)
{
  $content = strtr($content, "абвгдеёжзийклмнорпстуфхцчшщъьыэюя", "АБВГДЕЁЖЗИЙКЛМНОРПСТУФХЦЧШЩЪЬЫЭЮЯ");
  return (strtoupper($content));
}
}


if (!function_exists("clean"))
{
function clean($text)
{
  if (is_string($text))
  {
    $text = strip_tags($text);
    $text = str_replace("*"," ",$text);
    $text = str_replace("["," ",$text);
    $text = str_replace("]"," ",$text);
    $text = str_replace("|"," ",$text);
    $text = str_replace("*"," ",$text);
    $text = preg_replace("#\n#Uu"," ",$text);
    $text = preg_replace("#&.+;|http://.*(\.| )#Uu"," ",$text);
    $text = preg_replace("#[\.\?\!]+( |)*$#","",$text);
    $text = preg_replace("#[.]{2,}#",".",$text);
    $text = preg_replace("#[ ]{2,}#"," ",$text);
    $text = trim($text);
    $text = end_string($text);
  }
  else
  {
    if (is_array($text))
    {
      foreach ($text as $str)
      {
        $str = strip_tags($str);
        $str = str_replace("["," ",$str);
        $str = str_replace("]"," ",$str);
        $str = str_replace("|"," ",$str);
        $str = str_replace("*"," ",$str);
        $str = preg_replace("#\n#Uu"," ",$str);
        $str = preg_replace("#&.+;|http://.* #Uu"," ",$str);
        $str = preg_replace("#[\.\?\!:;]+( |)*$#","",$str);
        $str = preg_replace("#[.]{2,}#",".",$str);
        $str = preg_replace("#[ ]{2,}#"," ",$str);
        $str = trim($str);

        $str = end_string($str);

        $text2[] = $str;
      }
    }
            
    $text = $text2;
  }
        
  return $text;
}
}



if (!function_exists("end_string"))
{
function end_string($str)
{
  $str = preg_replace("#( .{1,4}|[,]+)$#","",$str);
  if (preg_match("#( .{1,4}|[,]+)$#",$str))
  {
    while (preg_match("#( .{1,4}|[,]+)$#",$str))
    {
      $str = preg_replace("#( .{1,4}|[,]+)$#","",$str);
    }
  }
  else
  {
    $str = preg_replace("#\.(| )$#","",$str);
    $str = preg_replace("#^\.| \.#"," ",$str);
    $str = trim($str);
    if ($str!="") $str=$str.".";
  }

  return $str;
}
}

?>
